%%% Display_Results_PSO



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Numerical results
%-------------------------------------------------------------------------- 
% display best params, this only makes sense for static functions, for dynamic
% you'd want to see a time history of expected versus optimized global best
% values.
disp(' ');
disp(' ');
disp(['Best fit parameters: ']);
disp([' cost = ',functname,'( [ input1, input2 ] )']);
disp(['---------------------------------']);

Estimated_Values=zeros(1,dims);
for index_Unknown=1:dims
disp(['      input',num2str(index_Unknown),' = ',num2str(pso_out(index_Unknown))]);
Estimated_Values(index_Unknown)=pso_out(index_Unknown);
end

disp(['        cost = ',num2str(pso_out(dims+1))]);
disp(['   mean cost = ',num2str(mean(te))]);
disp([' # of epochs = ',num2str(tr(end))]);


if exist('Set_Unknow_Values')==1
disp(['--------------------------']);

for index_Unknown=1:dims
disp(['Actual value: ',num2str(Set_Unknow_Values(index_Unknown)),';      Estimated value: ',num2str(Estimated_Values(index_Unknown))]);
end

disp(['--------------------------']);
end

% disp('Estimated values');
% disp(pso_out(1:dims)')

Evaluation_At_Found_Minimum= feval(functname,conj(Estimated_Values(:)'))
% Complex_Signal_Norm

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Visual results
%% optional, save picture
% set(gcf,'InvertHardcopy','off');
% print -depsc -r650 Results_PSO
% print('-djpeg',['demoPSOBehavior.jpg']);







