function [out]=Complex_Signal_Norm(in)

global Test_Signal

Size_in=size(in);
%%% Number of rows: number of particles (+1 when the Gbest is added as last row)
%%% Number of columns: number of unknowns (dimensionnality of the problem)

% out: 
%%% Number of rows= number of particles
%%% Number of columns: 1

Current_Signal=Compute_Signal_Instances(in);
%%% One row is for one particle
%%% One column is for one unknown

if size(Test_Signal,2)~=Size_in(2)
%%% This case comes when we want to display the value of the criterion
%%% versus 2 parameters only.
%%% In this case we have to redefine the signal for the values inside '' 
Param1=1;Param2=2;
%%% We assume the first and second parameters are selected for teh
%%% representation (found heuristically).

Test_Signal_Selected_Components=Test_Signal(Param1,Param2);

else
    Test_Signal_Selected_Components=Test_Signal;
end



%%% Our goal is to retrieve the parameters which characterize the signal 'Test_Signal'
%%% By minimizing the differene between a current_Signal modified
%%% recursively and this Test_Signal.

Size_in
size(Test_Signal)

Test_Signal_Replicated_All_Particles=zeros(Size_in);
for Ind_Row_All_Particles=1:Size_in(1)
Test_Signal_Replicated_All_Particles(Ind_Row_All_Particles,:)=Test_Signal_Selected_Components;    
end


Diff_Input_Current=Test_Signal_Replicated_All_Particles-Current_Signal;

out=sum(abs(Diff_Input_Current).^2,2);
%%% One row is for one particle.
%%% The column contains the criterion for all particles.

